// $Id$
// @version SlUser
// @package About
// @copyright Copyright wene / ssm2017 Binder (C) 2009. All rights reserved.
// @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
// SlUser is free software and parts of it may contain or be derived from the GNU General Public License
// or other free or open source software licenses.

string website_link = "/sluser/terminals/about";
// **********************
//              STRINGS
// **********************
// === user ===
string _ABOUT = "About";
string _ABOUT_TEXT_1 = "This terminal is using the website";
string _ABOUT_TEXT_2 = "to register users. Click on the link button to go to a page that will give you more infos.";
string _LINK = "Link";
string _LINK_TEXT = "Visit our website";
// ===================================================
//          NOTHING SHOULD BE CHANGED UNDER THIS LINE
// ===================================================
// **********************
//          VARS
// **********************
string url = "";
string url2 = "";
string password = "";
integer display_info = 1;
integer update_speed = 30;
integer busy_time = 30;
key owner;
integer busy = FALSE;
key actual_user = NULL_KEY;
// menu
integer menu_channel;
integer menu_listener;
// **********************
//          FUNCTIONS
// **********************
// parse parameters
integer parseParams(string params)
{
    // url ; url2 ; display_info ; update_speed ; busy_time
    list values = llParseStringKeepNulls(params, ["|"], []);
    url = llList2String(values, 0);
    url2 = llList2String(values, 1);
    password = llList2String(values, 2);
    display_info = llList2Integer(values, 3);
    update_speed = llList2Integer(values, 4);
    busy_time = llList2Integer(values, 5);
    if (url != "" && url2 != "")
    {
        return TRUE;
    }
    return FALSE;
}
// **********************
//          MAIN ENTRY
// **********************
default
{
    state_entry()
    {
        owner = llGetOwner();
        menu_channel = llFloor(llFrand(100000.0)) + 1000;
    }
    link_message(integer sender_num, integer num, string str, key id)
    {
        string cmd = (string)id;
        if (cmd == "ready")
        {
            state getParams;
        }
        else if (cmd == "reset")
        {
            llResetScript();
        }
    }
}
// **********************
//          GET PARAMS
// **********************
state getParams
{
    state_entry()
    {
        llMessageLinked(LINK_THIS, 0, _ABOUT, (key)"addApp");
        llMessageLinked(LINK_THIS, 0, "", (key)"getParams");
    }
    link_message(integer sender_num, integer num, string str, key id)
    {
        string cmd = (string)id;
        if (cmd == "setParams")
        {
            if (parseParams(str))
            {
                state run;
            }
            else
            {
                llOwnerSay("parse params error in about module");
            }
        }
        else if (cmd == "reset")
        {
            llResetScript();
        }
    }
}
// **********************
//          RUN MODE
// **********************
state run
{
    link_message(integer sender_num, integer num, string str, key id)
    {
        string cmd = (string)id;
        if (cmd == "setBusy")
        {
            busy = TRUE;
            actual_user = (key)str;
        }
        else if (cmd == "setEnabled")
        {
            busy = FALSE;
            actual_user = NULL_KEY;
        }
        else if (cmd == "setActualUser")
        {
            actual_user = (key)str;
        }
        else if (cmd == "menuAnswer")
        {
            if (str == _ABOUT)
            {
                menu_listener = llListen(menu_channel,"", actual_user,"");
                llDialog(actual_user, _ABOUT_TEXT_1 + " " +url+ " " + _ABOUT_TEXT_2, [_LINK], menu_channel);
            }
        }
        else if (cmd == "reset")
        {
            llResetScript();
        }
    }
    listen(integer channel, string name, key id, string message)
    {
        if ( channel == menu_channel )
        {
            if ( message == _LINK )
            {
                llLoadURL(actual_user, _LINK_TEXT, url+website_link);
            }
            llListenRemove(menu_listener);
        }
    }
}