// $Id$
// @version SlUser
// @package CheckUser
// @copyright Copyright wene / ssm2017 Binder (C) 2009. All rights reserved.
// @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
// SlUser is free software and parts of it may contain or be derived from the GNU General Public License
// or other free or open source software licenses.

// **********************
//              STRINGS
// **********************
// === user ===
string _CHECKING_THE_REGKEY = "Checking the reg key";
string _ENTER_YOUR_REG_CODE_PLEASE = "Enter your reg code please";
string _CHECK_KEY = "Check key";
// ===================================================
//          NOTHING SHOULD BE CHANGED UNDER THIS LINE
// ===================================================
// **********************
//          VARS
// **********************
string url = "";
string url2 = "";
string password = "";
integer display_info = 1;
integer update_speed = 30;
integer busy_time = 30;
key owner;
integer busy = FALSE;
key actual_user = NULL_KEY;
integer listener;
// **********************
//          FUNCTIONS
// **********************
integer parseParams(string params)
{
    // url ; url2 ; display_info ; update_speed ; busy_time
    list values = llParseStringKeepNulls(params, ["|"], []);
    url = llList2String(values, 0);
    url2 = llList2String(values, 1);
    password = llList2String(values, 2);
    display_info = llList2Integer(values, 3);
    update_speed = llList2Integer(values, 4);
    busy_time = llList2Integer(values, 5);
    if (url != "" && url2 != "")
    {
        return TRUE;
    }
    return FALSE;
}
// **********************
//          HTTP
// **********************
// check reg key
key checkRegKeyId;
checkRegKey(key userKey, string regKey)
{
    if ( display_info )
    {
        llOwnerSay(_CHECKING_THE_REGKEY);
    }
    // build password
    integer keypass = (integer)llFrand(9999)+1;
    string md5pass = llMD5String(password, keypass);
    // send the request
    checkRegKeyId = llHTTPRequest( url+url2, [HTTP_METHOD, "POST", HTTP_MIMETYPE, "application/x-www-form-urlencoded"],
                        // common values
                        "app=sluser"
                        +"&cmd=checkRegKey"
                        +"&output_type=message"
                        +"&arg="
                        // password
                        +"password="+md5pass+":"
                        +"keypass="+(string)keypass+":"
                        // user values
                        +"user_key="+ (string)userKey+":"
                        +"user_name="+ llKey2Name(userKey)+":"
                        +"reg_key="+ regKey);
}
// **********************
//          MAIN ENTRY
// **********************
default
{
    state_entry()
    {
        owner = llGetOwner();
    }
    link_message(integer sender_num, integer num, string str, key id)
    {
        string cmd = (string)id;
        if (cmd == "ready")
        {
            state getParams;
        }
        else if (cmd == "reset")
        {
            llResetScript();
        }
    }
}
// **********************
//          GET PARAMS
// **********************
state getParams
{
    state_entry()
    {
        llMessageLinked(LINK_THIS, 0, _CHECK_KEY, (key)"addApp");
        llMessageLinked(LINK_THIS, 0, "", (key)"getParams");
    }
    link_message(integer sender_num, integer num, string str, key id)
    {
        string cmd = (string)id;
        if (cmd == "setParams")
        {
            if (parseParams(str))
            {
                state run;
            }
        }
        else if (cmd == "reset")
        {
            llResetScript();
        }
    }
}
// **********************
//          RUN MODE
// **********************
state run
{
    listen(integer channel, string name, key id, string message)
    {
        if (channel == 0)
        {
            llInstantMessage(id, _CHECKING_THE_REGKEY);
            llMessageLinked(LINK_THIS, 0, "", (key)"setEnabled");
            llListenRemove(listener);
            actual_user = NULL_KEY;
            checkRegKey(id, message);
        }
    }
    link_message(integer sender_num, integer num, string str, key id)
    {
        string cmd = (string)id;
        if (cmd == "setBusy")
        {
            busy = TRUE;
            actual_user = (key)str;
        }
        else if (cmd == "setEnabled")
        {
            llListenRemove(listener);
            busy = FALSE;
            actual_user = NULL_KEY;
        }
        else if (cmd == "setActualUser")
        {
            actual_user = (key)str;
        }
        else if (cmd == "menuAnswer")
        {
            if (str == _CHECK_KEY)
            {
                llMessageLinked(LINK_THIS, 0, (string)actual_user, (key)"setBusy");
                llInstantMessage(actual_user, _ENTER_YOUR_REG_CODE_PLEASE);
                listener = llListen(0, "", actual_user, "");
            }
        }
        else if (cmd == "reset")
        {
            llResetScript();
        }
    }
    http_response(key request_id, integer status, list metadata, string body)
    {
        // get values
        body = llStringTrim( body , STRING_TRIM);
        list values = llParseStringKeepNulls(body, [";"], []);
        string msg = llList2String(values, 0);
        string value = llList2String(values, 1);

        if ( request_id == checkRegKeyId )
        {
            list data = llParseStringKeepNulls(value, ["|"], []);
            string message = llList2String(data, 0);
            string userKey = llList2String(data, 1);
            if ( msg == "success")
            {
                llInstantMessage((key)userKey, message);
            }
            else if ( msg == "error" )
            {
                llInstantMessage((key)userKey, message);
            }
        }
    }
}