// $Id: terminal.lsl,v 1.2 2009/01/21 23:20:56 ssm2017binder Exp $
// @version SlUser
// @package Terminal
// @copyright Copyright wene / ssm2017 Binder (C) 2009. All rights reserved.
// @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
// SlUser is free software and parts of it may contain or be derived from the GNU General Public License
// or other free or open source software licenses.

// **********************
//      USER PREFS
// **********************
// url ex: string url = "http://test.com";
string url = "http://alpha.sebmas.net/dp";
// password
string password = "0000";
// infos
integer display_info = 0;
// update speed
integer update_speed = 60;
// busy time
integer busy_time = 30;
// **********************
//  DRUPAL VERSION URL
// **********************
string url2 = "/secondlife";
// **********************
//              STRINGS
// **********************
// === common ===
string _RESET = "Reset";
string _CHOOSE_AN_OPTION = "Choose an option";
string _SCRIPT_WILL_STOP = "The script will stop";
string _ENTERING_WAIT_MODE = "Entering wait mode";
// === user ===
string _REGISTER = "Register";
string _ONLY_ONE_USER_AT_A_TIME = "Only one user can use the terminal at a time";
string _ONLY_ONE_REQUEST_AT_A_TIME = "Only one request can be done at a time";
// === terminal ===
string _REGISTERING_THE_TERMINAL = "Registering the terminal";
string _UPDATING_THE_TERMINAL = "Updating the terminal";
// === terminal status ===
string _TERMINAL_IS_DISABLED = "Terminal is disabled";
string _TERMINAL_IS_ENABLED = "Terminal is enabled";
string _TERMINAL_IS_BUSY = "Terminal is busy";
// ===================================================
//          NOTHING SHOULD BE CHANGED UNDER THIS LINE
// ===================================================
// **********************
//      VARS
// **********************
key owner;
string owner_name;
key rpc_channel;
integer update_time;
integer act_time;
integer countdown = FALSE;
// menu
integer menu_listener;
integer menu_channel;
// user
integer request_time;
integer busy = FALSE;
key actual_user = NULL_KEY;
// **********************
//      CALL THE MENU
// **********************
list apps_menu = [];
callMenu(key dest, string question, list choice)
{
    list menu;
    menu = apps_menu;
    if (llGetListLength(choice) > 0)
    {
        menu = choice;
    }
    menu_listener = llListen(menu_channel,"", dest,"");
    llDialog(dest, question+" : ", menu, menu_channel);
}
// ************************************
//      GIVE VALUES TO OTHER SCRIPT
// ************************************
giveParams()
{
    // url | url2 | password | display_info | update_speed | busy_time
    string params = url+"|"+url2+"|"+password+"|"+(string)display_info+"|"+(string)update_speed+"|"+(string)busy_time;
    llMessageLinked(LINK_THIS, 0, params, (key)"setParams");
}
// **************************
//      SET MESSSAGE
// **************************
setMessage(string status)
{
    string message = "";
    if (status == "enabled")
    {
        busy = FALSE;
        message = _TERMINAL_IS_ENABLED;
    }
    else if (status == "disabled")
    {
        message = _TERMINAL_IS_DISABLED;
    }
    else if (status == "busy")
    {
        busy = TRUE;
        message = _TERMINAL_IS_BUSY;
    }
    llSetText(message, <0.,1.,0.>, 1.);
}
// **********************
//          HTTP
// **********************
// register terminal
key registerTerminalId;
registerTerminal()
{
    if ( display_info )
    {
        llOwnerSay(_REGISTERING_THE_TERMINAL);
    }
    // build password
    integer keypass = (integer)llFrand(9999)+1;
    string md5pass = llMD5String(password, keypass);
    // send the request
    registerTerminalId = llHTTPRequest( url+url2, [HTTP_METHOD, "POST", HTTP_MIMETYPE, "application/x-www-form-urlencoded"],
                        // common values
                        "app=sluser"
                        +"&cmd=registerTerminal"
                        +"&output_type=message"
                        +"&arg="
                        // password
                        +"password="+md5pass+":"
                        +"keypass="+(string)keypass);
}
// update terminal
key updateTerminalId;
updateTerminal()
{
    if ( display_info )
    {
        llOwnerSay(_UPDATING_THE_TERMINAL);
    }
    // build password
    integer keypass = (integer)llFrand(9999)+1;
    string md5pass = llMD5String(password, keypass);
    // send the request
    updateTerminalId = llHTTPRequest( url+url2, [HTTP_METHOD, "POST", HTTP_MIMETYPE, "application/x-www-form-urlencoded"],
                        // common values
                        "app=sluser"
                        +"&cmd=updateTerminal"
                        +"&output_type=message"
                        +"&arg="
                        // password
                        +"password="+md5pass+":"
                        +"keypass="+(string)keypass+":"
                        // terminal values
                        +"rpc_channel="+(string)rpc_channel);
}
// ************************
//    CHECK REGISTRATION
// ************************
default
{
    on_rez(integer nbr)
    {
        llResetScript();
    }
    state_entry()
    {
        // setup vars
        owner = llGetOwner();
        owner_name = llKey2Name(owner);
        menu_channel = llFloor(llFrand(100000.0)) + 1000;
        // set message
        setMessage("disabled");
    }
    touch_start(integer total_number)
    {
        if ( llDetectedKey(0) == owner )
        {
            callMenu(owner, _CHOOSE_AN_OPTION, [_RESET, _REGISTER]);
        }
    }
    listen(integer channel, string name, key id, string message)
    {
        if ( channel == menu_channel )
        {
            if ( message == _RESET )
            {
                llMessageLinked(LINK_THIS, 0, "", (key)"reset");
                llResetScript();
            }
            else if ( message == _REGISTER )
            {
                registerTerminal();
            }
            llListenRemove(menu_listener);
        }
    }
    http_response(key request_id, integer status, list metadata, string body)
    {
        // get the values
        body = llStringTrim( body , STRING_TRIM);
        list values = llParseStringKeepNulls(body,[";"],[]);
        string msg = llList2String(values, 0);
        string value = llList2String(values, 1);

        if ( request_id == registerTerminalId )
        {
            if ( msg == "success" )
            {
                llOwnerSay(value);
                state wait;
            }
            else if ( msg == "error" )
            {
                llOwnerSay(value);
                llOwnerSay(_SCRIPT_WILL_STOP);
                return;
            }
        }
    }
}
// ************************
//            WAIT MODE
// ************************
state wait
{
    on_rez(integer nbr)
    {
        llResetScript();
    }
    state_entry()
    {
        llMessageLinked(LINK_THIS, 0, "", (key)"ready");
        llMessageLinked(LINK_THIS, 0, "", (key)"setEnabled");
        update_time = llGetUnixTime() + update_speed;
        llOwnerSay(_ENTERING_WAIT_MODE);
        llSetTimerEvent(1);
    }
    touch_start(integer total_number)
    {
        key toucher = llDetectedKey(0);
        if ( toucher == owner )
        {
            callMenu(owner, _CHOOSE_AN_OPTION, [ _RESET]);
        }
        else
        {
            if (busy && toucher != actual_user)
            {
                llInstantMessage(toucher, _ONLY_ONE_USER_AT_A_TIME);
            }
            else if (busy && toucher == actual_user)
            {
                llInstantMessage(toucher, _ONLY_ONE_REQUEST_AT_A_TIME);
            }
            else if (!busy || toucher == actual_user)
            {
                if (llGetListLength(apps_menu) > 0)
                {
                    actual_user = toucher;
                    // llMessageLinked(LINK_THIS, 0, (string)actual_user, (key)"setBusy");
                    llMessageLinked(LINK_THIS, 0, (string)actual_user, (key)"setActualUser");
                    llMessageLinked(LINK_THIS, 0, "", (key)"callMenu");
                }
            }
        }
    }
    listen(integer channel, string name, key id, string message)
    {
        if ( channel == menu_channel )
        {
            llMessageLinked(LINK_THIS, 0, message, (key)"menuAnswer");
            if ( id == owner )
            {
                if ( message == _RESET )
                {
                    llMessageLinked(LINK_THIS, 0, "", (key)"reset");
                    llResetScript();
                }
            }
        }
    }
    link_message(integer sender_num, integer num, string str, key id)
    {
        string cmd = (string)id;
        if (cmd == "getParams")
        {
            giveParams();
        }
        else if (cmd == "setBusy")
        {
            setMessage("busy");
            actual_user = (key)str;
            request_time = llGetUnixTime();
        }
        else if (cmd == "setEnabled")
        {
            setMessage("enabled");
            actual_user = NULL_KEY;
            request_time = 0;
        }
        else if (cmd == "addApp")
        {
            apps_menu = (apps_menu=[]) + apps_menu + [str];
        }
        else if (cmd == "callMenu")
        {
            list options = [];
            if (str != "")
            {
                options = llCSV2List(str);
            }
            callMenu(actual_user, _CHOOSE_AN_OPTION, options);
        }
        else if (cmd == "countdown")
        {
            if (str == "TRUE")
            {
                countdown = TRUE;
            }
            else
            {
                countdown = FALSE;
            }
        }
        else if (cmd == "reset")
        {
            llResetScript();
        }
    }
    timer()
    {
        act_time = llGetUnixTime();
        if (countdown)
        {
            llInstantMessage(actual_user, (string)(busy_time - (act_time - request_time)));
        }
        if (busy && (act_time - request_time) >= busy_time)
        {
            llMessageLinked(LINK_THIS, 0, "", (key)"setEnabled");
            countdown = FALSE;
        }
        if (act_time >= update_time)
        {
            update_time = act_time + update_speed;
            llOpenRemoteDataChannel();
        }
    }
    remote_data(integer type, key channel, key message_id, string sender, integer ival, string sval) 
    {
        if ( type & REMOTE_DATA_CHANNEL )
        {
            rpc_channel = channel;
            updateTerminal();
        }
        else if (type & REMOTE_DATA_REQUEST)
        {
            list values = llParseString2List(sval, [";"], []);
            string command = llList2String(values, 0);
            string answer;
            if ( command == "check status" )
            {
                answer = "online";
            }
            llRemoteDataReply(channel, message_id, answer, 1);
        }
    }
}