// $Id$
// @version SlUser
// @package SlPoints
// @copyright Copyright wene / ssm2017 Binder (C) 2009. All rights reserved.
// @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
// SlUser is free software and parts of it may contain or be derived from the GNU General Public License
// or other free or open source software licenses.

// todo : check if no site or no module
// todo : write watchdog entry

// **********************
//          STRINGS
// **********************
string _ADD_MONEY = "Add money";
string _GETTING_POINTS = "Getting points";
string _SETTING_POINTS = "Setting points";
string _REFUNDING = "Refunding";
string _ONLY_ONE_USER_PER_REQUEST_PLEASE = "Only one user per request please";
// ===================================================
//          NOTHING SHOULD BE CHANGED UNDER THIS LINE
// ===================================================
// **********************
//          VARS
// **********************
string url = "";
string url2 = "";
string password = "";
integer display_info = 1;
integer update_speed = 30;
integer busy_time = 30;
key owner;
integer busy = FALSE;
key actual_user = NULL_KEY;
integer listener;
// **********************
//          FUNCTIONS
// **********************
integer parseParams(string params)
{
    // url ; url2 ; display_info ; update_speed ; busy_time
    list values = llParseStringKeepNulls(params, ["|"], []);
    url = llList2String(values, 0);
    url2 = llList2String(values, 1);
    password = llList2String(values, 2);
    display_info = llList2Integer(values, 3);
    update_speed = llList2Integer(values, 4);
    busy_time = llList2Integer(values, 5);
    if (url != "" && url2 != "")
    {
        return TRUE;
    }
    return FALSE;
}
// **********************
//          HTTP
// **********************
// get points
key getPointsId;
getPoints(key userKey)
{
    if ( display_info )
    {
        llOwnerSay(_GETTING_POINTS);
    }
    // build password
    integer keypass = (integer)llFrand(9999)+1;
    string md5pass = llMD5String(password, keypass);
    // send the request
    getPointsId = llHTTPRequest( url+url2, [HTTP_METHOD, "POST", HTTP_MIMETYPE, "application/x-www-form-urlencoded"],
                        // common values
                        "app=slpoints"
                        +"&cmd=getPoints"
                        +"&output_type=message"
                        +"&arg="
                        // password
                        +"password="+md5pass+":"
                        +"keypass="+(string)keypass+":"
                        // user values
                        +"user_key="+(string)userKey+":"
                        +"user_name="+llKey2Name(userKey));
}
// set points
key setPointsId;
setPoints(integer amount, key userKey)
{
    if ( display_info )
    {
        llOwnerSay(_SETTING_POINTS);
    }
    // build password
    integer keypass = (integer)llFrand(9999)+1;
    string md5pass = llMD5String(password, keypass);
    // send the request
    setPointsId = llHTTPRequest( url+url2, [HTTP_METHOD, "POST", HTTP_MIMETYPE, "application/x-www-form-urlencoded"],
                        // common values
                        "app=slpoints"
                        +"&cmd=setPoints"
                        +"&output_type=message"
                        +"&arg="
                        // password
                        +"password="+md5pass+":"
                        +"keypass="+(string)keypass+":"
                        // user values
                        +"amount="+(string)amount+":"
                        +"user_key="+(string)userKey+":"
                        +"user_name="+llKey2Name(userKey));
}
// **********************
//          MAIN ENTRY
// **********************
default
{
    state_entry()
    {
        owner = llGetOwner();
    }
    link_message(integer sender_num, integer num, string str, key id)
    {
        string cmd = (string)id;
        if (cmd == "ready")
        {
            state getParams;
        }
    }
}
// **********************
//          GET PARAMS
// **********************
state getParams
{
    state_entry()
    {
        llMessageLinked(LINK_THIS, 0, _ADD_MONEY, (key)"addApp");
        llMessageLinked(LINK_THIS, 0, "", (key)"getParams");
    }
    link_message(integer sender_num, integer num, string str, key id)
    {
        string cmd = (string)id;
        if (cmd == "setParams")
        {
            if (parseParams(str))
            {
                state getPerms;
            }
        }
        else if (cmd == "reset")
        {
            llResetScript();
        }
    }
}
// **********************
//          GET PERMS
// **********************
state getPerms
{
    state_entry()
    {
        llRequestPermissions(llGetOwner(), PERMISSION_DEBIT);
    }
    run_time_permissions(integer perms)
    {
        if (perms & PERMISSION_DEBIT)
        {
            state wait;
        }
    }
    link_message(integer sender_num, integer num, string str, key id)
    {
        string cmd = (string)id;
        if (cmd == "reset")
        {
            llResetScript();
        }
    }
}
// ************************
//            WAIT MODE
// ************************
state wait
{
    link_message(integer sender_num, integer num, string str, key id)
    {
        string cmd = (string)id;
        if (cmd == "setBusy")
        {
            busy = TRUE;
            actual_user = (key)str;
        }
        else if (cmd == "setEnabled")
        {
            busy = FALSE;
            actual_user = NULL_KEY;
        }
        else if (cmd == "setActualUser")
        {
            actual_user = (key)str;
        }
        else if (cmd == "menuAnswer")
        {
            if (str == _ADD_MONEY)
            {
                llMessageLinked(LINK_THIS, 0, (string)actual_user, (key)"setBusy");
                state addMoney;
            }
        }
        else if (cmd == "reset")
        {
            llResetScript();
        }
    }
}
// ************************
//            ADD MONEY
// ************************
state addMoney
{
    money(key giver, integer amount)
    {
        if (giver == actual_user)
        {
            setPoints(amount, giver);
        }
        else
        {
            llInstantMessage(giver, _ONLY_ONE_USER_PER_REQUEST_PLEASE);
            llGiveMoney(giver, amount);
            llInstantMessage(giver, _REFUNDING);
        }
    }
    link_message(integer sender_num, integer num, string str, key id)
    {
        string cmd = (string)id;
        if (cmd == "setEnabled")
        {
            busy = FALSE;
            actual_user = NULL_KEY;
            state wait;
        }
        else if (cmd == "reset")
        {
            llResetScript();
        }
    }
    http_response(key request_id, integer status, list metadata, string body)
    {
        // get the values
        body = llStringTrim( body , STRING_TRIM);
        list values = llParseStringKeepNulls(body,[";"],[]);
        string msg = llList2String(values, 0);
        string value = llList2String(values, 1);

        if ( request_id == getPointsId || request_id == setPointsId )
        {
            list data = llParseStringKeepNulls(value, ["|"], []);
            string message = llList2String(data, 0);
            string userKey = llList2String(data, 1);
            integer amount = llList2Integer(data, 2);
            if ( msg == "success")
            {
                llInstantMessage((key)userKey, message);
            }
            else if ( msg == "error" )
            {
                llInstantMessage((key)userKey, message);
                llGiveMoney(userKey, amount);
                llInstantMessage((key)userKey, _REFUNDING);
            }
            llMessageLinked(LINK_THIS, 0, (string)actual_user, (key)"setEnabled");
            state wait;
        }
    }
}