// $Id$
// @version SlUser
// @package RegUser
// @copyright Copyright wene / ssm2017 Binder (C) 2009. All rights reserved.
// @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
// SlUser is free software and parts of it may contain or be derived from the GNU General Public License
// or other free or open source software licenses.

string reg_card_name = "register";
// **********************
//              STRINGS
// **********************
// === user ===
string _REGISTER = "Register";
string _YOU_HAVE = "You have";
string _SECS_TO_DRAG_THE_NOTECARD = "seconds to drag the notecard.";
// === registration ===
string _CHECKING_REGISTRATION = "Checking registration";
string _REGISTERING_USER = "Registering user";
string _REGISTER_USER = "Reg user";
string _CHECK_VALUES_BEFORE_REGISTERING = "Check values before registering";
// === notecard ===
string _GET_REG_CARD = "Get reg card";
string _REG_CARD_IS_MISSING = "Reg card example is missing";
string _START_READING_CONFIG_NOTECARD = "Start reading notecard";
string _NOTECARD_IS_MISSING = "Notecard is missing";
string _CONFIG_NOTECARD_READ = "Config notecard read";
string _CHECK_USERNAME = "Check username";
string _CHECK_SL_USERNAME = "Check sl username";
string _CHECK_PASSWORD = "Check password";
string _CHECK_EMAIL = "Check email";
// ===================================================
//          NOTHING SHOULD BE CHANGED UNDER THIS LINE
// ===================================================
// **********************
//          VARS
// **********************
string url = "";
string url2 = "";
string password = "";
integer display_info = 1;
integer update_speed = 30;
integer busy_time = 30;
key owner;
integer busy = FALSE;
key actual_user = NULL_KEY;
integer listener;
// notecard vars
list inventory = [];
integer start_notecard_count = 0;
integer iLine = 0;
key configNoteCard;
string notecard_name;
// menu
integer menu_listener;
integer menu_channel;
// user registration
string user_website_username;
string user_sl_username;
string user_password;
string user_email_address;
// **********************
//          FUNCTIONS
// **********************
// parse parameters
integer parseParams(string params)
{
    // url ; url2 ; display_info ; update_speed ; busy_time
    list values = llParseStringKeepNulls(params, ["|"], []);
    url = llList2String(values, 0);
    url2 = llList2String(values, 1);
    password = llList2String(values, 2);
    display_info = llList2Integer(values, 3);
    update_speed = llList2Integer(values, 4);
    busy_time = llList2Integer(values, 5);
    if (url != "" && url2 != "")
    {
        return TRUE;
    }
    return FALSE;
}
// get inventory
getInventory()
{
    integer num = llGetInventoryNumber(INVENTORY_ALL);
    integer i;
    for (i = 0; i < num; ++i) {
        inventory = (inventory=[]) + inventory + [llGetInventoryName(INVENTORY_ALL, i)];
    }
}
// clean inventory
cleanInventory()
{
    integer num = llGetInventoryNumber(INVENTORY_ALL);
    string name;
    integer i;
    for (i = 0; i < num; ++i) {
        name = llGetInventoryName(INVENTORY_ALL, i);
        if (llListFindList(inventory, [name]) == -1)
        {
            llRemoveInventory(name);
        }
    }
}
// **********************
//          HTTP
// **********************
// register user
key checkRegistrationId;
checkRegistration()
{
    llInstantMessage(actual_user, _CHECKING_REGISTRATION);
    // build password
    integer keypass = (integer)llFrand(9999)+1;
    string md5pass = llMD5String(password, keypass);
    // send the request
    checkRegistrationId = llHTTPRequest( url+url2, [HTTP_METHOD, "POST", HTTP_MIMETYPE, "application/x-www-form-urlencoded"],
                        // common values
                        "app=slreguser"
                        +"&cmd=checkRegistration"
                        +"&output_type=message"
                        +"&arg="
                        // password
                        +"password="+md5pass+":"
                        +"keypass="+(string)keypass+":"
                        // user values
                        +"website_username="+user_website_username+":"
                        +"user_key="+(string)actual_user+":"
                        +"pass="+user_password+":"
                        +"email="+user_email_address);
}
// register save
key registerSaveId;
registerSave()
{
    llInstantMessage(actual_user, _REGISTERING_USER);
    // build password
    integer keypass = (integer)llFrand(9999)+1;
    string md5pass = llMD5String(password, keypass);
    // send the request
    registerSaveId = llHTTPRequest( url+url2, [HTTP_METHOD, "POST", HTTP_MIMETYPE, "application/x-www-form-urlencoded"],
                        // common values
                        "app=slreguser"
                        +"&cmd=registerUser"
                        +"&output_type=message"
                        +"&arg="
                        // password
                        +"password="+md5pass+":"
                        +"keypass="+(string)keypass+":"
                        // user values
                        +"website_username="+user_website_username+":"
                        +"email="+user_email_address+":"
                        +"user_key="+(string)actual_user+":"
                        +"sl_username="+llKey2Name(actual_user)+":"
                        +"pass="+user_password);
}
// **********************
//          MAIN ENTRY
// **********************
default
{
    state_entry()
    {
        owner = llGetOwner();
        getInventory();
        start_notecard_count = llGetInventoryNumber(INVENTORY_NOTECARD);
    }
    link_message(integer sender_num, integer num, string str, key id)
    {
        string cmd = (string)id;
        if (cmd == "ready")
        {
            if (llGetInventoryType(reg_card_name) != INVENTORY_NONE)
            {
                state getParams;
            }
            else
            {
                llOwnerSay(_REG_CARD_IS_MISSING);
            }
        }
        else if (cmd == "reset")
        {
            llResetScript();
        }
    }
}
// **********************
//          GET PARAMS
// **********************
state getParams
{
    state_entry()
    {
        llMessageLinked(LINK_THIS, 0, _REGISTER_USER, (key)"addApp");
        llMessageLinked(LINK_THIS, 0, _GET_REG_CARD, (key)"addApp");
        llMessageLinked(LINK_THIS, 0, "", (key)"getParams");
    }
    link_message(integer sender_num, integer num, string str, key id)
    {
        string cmd = (string)id;
        if (cmd == "setParams")
        {
            if (parseParams(str))
            {
                state run;
            }
        }
        else if (cmd == "reset")
        {
            llResetScript();
        }
    }
}
// **********************
//          RUN MODE
// **********************
state run
{
    link_message(integer sender_num, integer num, string str, key id)
    {
        string cmd = (string)id;
        if (cmd == "setBusy")
        {
            busy = TRUE;
            actual_user = (key)str;
        }
        else if (cmd == "setEnabled")
        {
            busy = FALSE;
            actual_user = NULL_KEY;
        }
        else if (cmd == "setActualUser")
        {
            actual_user = (key)str;
        }
        else if (cmd == "menuAnswer")
        {
            if (str == _GET_REG_CARD)
            {
                if (llGetInventoryType(reg_card_name) != INVENTORY_NONE)
                {
                    llGiveInventory(actual_user, reg_card_name);
                }
            }
            else if (str == _REGISTER_USER)
            {
                llMessageLinked(LINK_THIS, 0, (string)actual_user, (key)"setBusy");
                llMessageLinked(LINK_THIS, 0, "TRUE", (key)"countdown");
                llInstantMessage(actual_user, _YOU_HAVE + " " + (string)busy_time + " " + _SECS_TO_DRAG_THE_NOTECARD);
                llAllowInventoryDrop(TRUE);
            }
        }
        else if (cmd == "reset")
        {
            llResetScript();
        }
    }
    changed(integer mask)
    {
        if(mask & (CHANGED_ALLOWED_DROP | CHANGED_INVENTORY))
        {
            integer act_notecard_count = llGetInventoryNumber(INVENTORY_NOTECARD);
            if (act_notecard_count > start_notecard_count)
            {
                notecard_name = llGetInventoryName(INVENTORY_NOTECARD, start_notecard_count);
            }
            if (llGetInventoryType(notecard_name) != INVENTORY_NONE)
            {
                llMessageLinked(LINK_THIS, 0, "FALSE", (key)"countdown");
                state checkNotecard;
            }
            else
            {
                llInstantMessage(actual_user, _NOTECARD_IS_MISSING);
            }
        }
    }
}
// *************************
//      READ THE NOTECARD
// *************************
state checkNotecard
{
    on_rez(integer change)
    {
        llResetScript();
    }
    state_entry()
    {
        // read the notecard
        configNoteCard = llGetNotecardLine(notecard_name,iLine);
        llInstantMessage(actual_user, _START_READING_CONFIG_NOTECARD);
    }
    link_message(integer sender_num, integer num, string str, key id)
    {
        string cmd = (string)id;
        if (cmd == "setBusy")
        {
            busy = TRUE;
            actual_user = (key)str;
        }
        else if (cmd == "setEnabled")
        {
            busy = FALSE;
            actual_user = NULL_KEY;
        }
    }
    dataserver(key queryId, string data)
    {
        if (queryId == configNoteCard)
        {
            if(data != EOF)
            {
                if (llGetSubString( data, 0, 1) != "//")
                {
                    if (data != "")
                    {
                        list parsed = llParseString2List(data, [ "=" ], []);
                        string param = llToLower(llStringTrim(llList2String( parsed, 0 ), STRING_TRIM));
                        string value = llStringTrim(llList2String(parsed, 1), STRING_TRIM);
                        if (param != "")
                        {
                            if (param == "username")
                            {
                                user_website_username = value;
                            }
                            else if (param == "password")
                            {
                                user_password = value;
                            }
                            else if (param == "email")
                            {
                                user_email_address = value;
                            }
                        }
                    }
                }
                configNoteCard = llGetNotecardLine(notecard_name,++iLine);
            }
            else
            {
                llInstantMessage(actual_user, _CONFIG_NOTECARD_READ+" ...");
                // check values
                integer check = TRUE;
                if (user_website_username == "")
                {
                    llInstantMessage(actual_user, _CHECK_USERNAME);
                    check = FALSE;
                }
                if (user_password == "")
                {
                    llInstantMessage(actual_user, _CHECK_PASSWORD);
                    check = FALSE;
                }
                if (user_email_address == "")
                {
                    llInstantMessage(actual_user, _CHECK_EMAIL);
                    check = FALSE;
                }
                if (!check)
                {
                    llMessageLinked(LINK_THIS, 0, "", (key)"setEnabled");
                    state run;
                }
                else
                {
                    state register;
                }
            }
        }
    }
}
// ************************
//    CHECK REGISTRATION
// ************************
state register
{
    on_rez(integer nbr)
    {
        llResetScript();
    }
    state_entry()
    {
        llRemoveInventory(notecard_name);
        menu_channel = llFloor(llFrand(100000.0)) + 1000;
        checkRegistration();
    }
    link_message(integer sender_num, integer num, string str, key id)
    {
        string cmd = (string)id;
        if (cmd == "setBusy")
        {
            busy = TRUE;
            actual_user = (key)str;
        }
        else if (cmd == "setEnabled")
        {
            busy = FALSE;
            actual_user = NULL_KEY;
        }
    }
    listen(integer channel, string name, key id, string message)
    {
        if ( channel == menu_channel )
        {
            if ( message == _REGISTER_USER )
            {
                registerSave();
            }
            llListenRemove(menu_listener);
        }
    }
    http_response(key request_id, integer status, list metadata, string body)
    {
        body = llStringTrim( body , STRING_TRIM);
        list values = llParseStringKeepNulls(body,[";"],[]);
        string msg = llList2String(values, 0);
        string value = llList2String(values, 1);
        if ( request_id == checkRegistrationId )
        {
            if ( msg == "success" )
            {
                llInstantMessage(actual_user, value);
                menu_listener = llListen(menu_channel,"", actual_user,"");
                llDialog(actual_user, _CHECK_VALUES_BEFORE_REGISTERING+"\n username = "+user_website_username+"\n password = "+user_password+"\n email = "+user_email_address, [_REGISTER_USER], menu_channel);
            }
            else if ( msg == "registration closed" )
            {
                llInstantMessage(actual_user, value);
                llMessageLinked(LINK_THIS, 0, "", (key)"setEnabled");
                state run;
            }
            else if ( msg == "already registered" )
            {
                llInstantMessage(actual_user, value);
                llMessageLinked(LINK_THIS, 0, "", (key)"setEnabled");
                state run;
            }
            else if ( msg == "error" )
            {
                llInstantMessage(actual_user, value);
                llMessageLinked(LINK_THIS, 0, "", (key)"setEnabled");
                state run;
            }
        }
        else if ( request_id == registerSaveId )
        {
            if ( msg == "error" )
            {
                llInstantMessage(actual_user, value);
                state run;
            }
            else if ( msg == "success need activate" || msg == "success reg complete" )
            {
                llInstantMessage(actual_user, value);
                state run;
            }
            llMessageLinked(LINK_THIS, 0, "", (key)"setEnabled");
        }
    }
}